data Tree a = Tip a | Tree a :^: Tree a deriving Show

sort :: (Ord a) => [a] -> [a]
sort [] = []
sort (x:xs) = insert x (sort xs)

insert :: (Ord a) => a -> [a] -> [a]
insert x [] = [x]
insert x xxs@(x':xs) | x < x' = x : xxs
                     | otherwise = x' : insert x xs

sortTree :: (Ord a) => Tree a -> Tree a
sortTree t = t_tree
 where 
  (t_stips, t_ssorted, t_tree) = sortTree' t t_itips t_isorted
  t_itips = []
  t_isorted = sort t_stips

sortTree' :: Tree a -> [a] -> [b] -> ([a], [b], Tree b)
sortTree' (Tip a) t_itips t_isorted = 
  (t_stips, t_ssorted, t_tree)
 where 
  t_stips = a : t_itips
  t_ssorted = tail t_isorted
  t_tree = Tip (head t_isorted)
sortTree' (l:^:r) t_itips t_isorted = 
  (t_stips, t_ssorted, t_tree)
 where 
  (l_stips, l_ssorted, l_tree) = sortTree' l l_itips l_isorted
  (r_stips, r_ssorted, r_tree) = sortTree' r r_itips r_isorted
  r_itips = t_itips
  l_itips = r_stips
  t_stips = l_stips
  l_isorted = t_isorted
  r_isorted = l_ssorted
  t_ssorted = r_ssorted
  t_tree = l_tree :^: r_tree

aTree :: Tree Int
aTree = 
  (Tip 7 :^: (Tip 2 :^: Tip 5)) :^: (Tip 3 :^: Tip 1)

main = print (sortTree aTree)
